$SAFE = 2
$CUR = '%0.2f'

# ***** Code Fixes *****
# Overrides some methods in the base class String.
class String
	alias orig_to_f to_f
	alias orig_to_i to_i
	alias string_format %
	def to_f
		delete(',').orig_to_f
	end
	def to_i
		delete(',').orig_to_i
	end
	def %(arg)
		if (arg.kind_of?(Array) or index('f') == nil)
			string_format(arg)
		else
			value = arg.to_f
			string_format(value < 0.0 ? value - 0.00000001 : value + 0.00000001)
		end
	end

end

# ***** Profile Classes *****
class Individual
 def first_name; ''; end
 def middle_initial; ''; end
 def last_name; ''; end
 def suffix; ''; end
 def address; ''; end
 def apartment_number; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def work_phone; ''; end
 def mobile_phone; ''; end
 def fax; ''; end
 def ssn; ''; end
 def occupation; ''; end
 def county; ''; end
 def school_code; ''; end
 def email; ''; end
 def blind; ''; end
 def sixty_five_plus; ''; end
 def spouse_first_name; ''; end
 def spouse_middle_initial; ''; end
 def spouse_last_name; ''; end
 def spouse_suffix; ''; end
 def spouse_address; ''; end
 def spouse_apartment_number; ''; end
 def spouse_city; ''; end
 def spouse_state; ''; end
 def spouse_zip; ''; end
 def spouse_phone; ''; end
 def spouse_work_phone; ''; end
 def spouse_mobile_phone; ''; end
 def spouse_fax; ''; end
 def spouse_ssn; ''; end
 def spouse_occupation; ''; end
 def spouse_county; ''; end
 def spouse_school_code; ''; end
 def spouse_email; ''; end
 def spouse_blind; ''; end
 def spouse_65_plus; ''; end
 def single; ''; end
 def married_joint; ''; end
 def married_separate; ''; end
 def head_of_household; ''; end
 def widow_widower; ''; end
 def direct_deposit_checking; ''; end
 def direct_deposit_savings; ''; end
 def routing_number; ''; end
 def account_number; ''; end
 def dependent1_first_name; ''; end
 def dependent1_last_name; ''; end
 def dependent1_ssn; ''; end
 def dependent1_relationship; ''; end
 def dependent1_dob; ''; end
 def dependent2_first_name; ''; end
 def dependent2_last_name; ''; end
 def dependent2_ssn; ''; end
 def dependent2_relationship; ''; end
 def dependent2_dob; ''; end
 def dependent3_first_name; ''; end
 def dependent3_last_name; ''; end
 def dependent3_ssn; ''; end
 def dependent3_relationship; ''; end
 def dependent3_dob; ''; end
 def dependent4_first_name; ''; end
 def dependent4_last_name; ''; end
 def dependent4_ssn; ''; end
 def dependent4_relationship; ''; end
 def dependent4_dob; ''; end
 def dependent5_first_name; ''; end
 def dependent5_last_name; ''; end
 def dependent5_ssn; ''; end
 def dependent5_relationship; ''; end
 def dependent5_dob; ''; end
 def dependent6_first_name; ''; end
 def dependent6_last_name; ''; end
 def dependent6_ssn; ''; end
 def dependent6_relationship; ''; end
 def dependent6_dob; ''; end
 def business_name; ''; end
 def business_address; ''; end
 def business_address2; ''; end
 def business_city; ''; end
 def business_state; ''; end
 def business_zip; ''; end
 def fein; ''; end
 def business_phone; ''; end
 def business_fax; ''; end
 def business_email; ''; end
end

class Preparer
 def first_name; ''; end
 def middle_initial; ''; end
 def last_name; ''; end
 def firm_name; ''; end
 def address; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def work_phone; ''; end
 def mobile_phone; ''; end
 def fax; ''; end
 def email; ''; end
 def fein; ''; end
 def ptin; ''; end
 def ssn; ''; end
 def self_employed; ''; end
end

class Entity
 def name; ''; end
 def address; ''; end
 def address2; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def fax; ''; end
 def email; ''; end
 def fein; ''; end
 def state_id; ''; end
 def date_started; ''; end
 def state_of_incorporation; ''; end
 def naics_code; ''; end
 def principal_activity; ''; end
 def contact_name; ''; end
 def contact_title; ''; end
 def contact_phone; ''; end
 def estate_name; ''; end
 def estate_ssn; ''; end
 def estate_dod; ''; end
 def agent_first_name; ''; end
 def agent_middle_initial; ''; end
 def agent_last_name; ''; end
 def agent_business_name; ''; end
 def agent_address; ''; end
 def agent_city; ''; end
 def agent_state; ''; end
 def agent_zip; ''; end
 def agent_phone; ''; end
end

class Fiduciary
 def first_name_and_mi; ''; end
 def last_name; ''; end
 def title; ''; end
 def address; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def ssn; ''; end
 def estate_name; ''; end
 def ein; ''; end
 def entity_creation_date; ''; end
 def entity_type_decendents; ''; end
 def entity_type_simple; ''; end
 def entity_type_complex; ''; end
 def entity_type_disability; ''; end
 def entity_type_esbt; ''; end
 def entity_type_grantor; ''; end
 def entity_type_bankruptcy_ch7; ''; end
 def entity_type_bankruptcy_ch11; ''; end
 def entity_type_pooled_income; ''; end
 def decedent_first_name_and_mi; ''; end
 def decedent_last_name; ''; end
 def decedent_address; ''; end
 def decedent_city; ''; end
 def decedent_state; ''; end
 def decedent_zip; ''; end
 def decedent_phone; ''; end
 def decedent_ssn; ''; end
 def decedent_dob; ''; end
 def decedent_dod; ''; end
end

class Equifax
def account_name; ''; end
def unemp_tax_yes; ''; end
def unemp_tax_no; ''; end
def local_wh_tax_yes; ''; end
def local_wh_tax_no; ''; end
def wh_tax_yes; ''; end
def wh_tax_no; ''; end
def emp_tax_consult_yes; ''; end
def emp_tax_consult_no; ''; end
def open_new_business; ''; end
def exist_entity_new_in_state; ''; end
def acquire_exist_business; ''; end
def reopen_inactiv_business; ''; end
def change_owner_type_entity; ''; end
def name_change; ''; end
def acct_closures; ''; end
def other_checkbox; ''; end
def other_list; ''; end
def succ_business_name; ''; end
def succ_trade_dba; ''; end
def succ_fein; ''; end
def succ_phone; ''; end
def succ_corp_address; ''; end
def succ_corp_address2; ''; end
def succ_corp_city; ''; end
def succ_corp_state; ''; end
def succ_corp_zip; ''; end
def succ_mailing_address; ''; end
def succ_mailing_address2; ''; end
def succ_mailing_city; ''; end
def succ_mailing_state; ''; end
def succ_mailing_zip; ''; end
def succ_contact_name; ''; end
def succ_contact_title; ''; end
def succ_contact_phone; ''; end
def succ_contact_fax; ''; end
def succ_contact_email; ''; end
def succ_entity_type_corp_public; ''; end
def succ_entity_type_corp_private; ''; end
def succ_entity_type_partnership; ''; end
def succ_entity_type_ltd_partnership; ''; end
def succ_entity_type_scorp; ''; end
def succ_entity_type_other_checkbox; ''; end
def succ_entity_type_other_list; ''; end
def succ_entity_type_llc; ''; end
def succ_entity_type_taxed_as_corp; ''; end
def succ_entity_type_taxed_as_partnership; ''; end
def succ_entity_type_disregarded_entity; ''; end
def succ_entity_type_disregarded_entity_member_name; ''; end
def succ_entity_type_disregarded_entity_member_fein; ''; end
def succ_entity_type_sole_proprietor; ''; end
def succ_state_of_incorporation; ''; end
def succ_date_started; ''; end
def succ_fiscal_yr_end_date; ''; end
def succ_acctng_method_cash; ''; end
def succ_acctng_method_accrual; ''; end
def succ_first_day_of_employment; ''; end
def succ_first_payroll_date; ''; end
def succ_nature_of_business_retail; ''; end
def succ_nature_of_business_wholesale; ''; end
def succ_nature_of_business_manufacturing; ''; end
def succ_nature_of_business_service; ''; end
def succ_nature_of_business_staffing_temp; ''; end
def succ_nature_of_business_prof_emp_org; ''; end
def succ_nature_of_business_other_checkbox; ''; end
def succ_nature_of_business_other_list; ''; end
def succ_business_activity_description; ''; end
def succ_naics_code; ''; end
def succ_501_c_3_exempt_yes; ''; end
def succ_501_c_3_exempt_no; ''; end
def succ_futa_yes; ''; end
def succ_futa_no; ''; end
def succ_futa_date_first_liability; ''; end
def succ_psp_na; ''; end
def succ_psp_name; ''; end
def succ_psp_contact_name; ''; end
def succ_psp_phone; ''; end
def succ_psp_address; ''; end
def succ_psp_city; ''; end
def succ_psp_state; ''; end
def succ_psp_zip; ''; end
def succ_bank_name; ''; end
def succ_bank_address; ''; end
def succ_bank_city; ''; end
def succ_bank_state; ''; end
def succ_bank_zip; ''; end
def succ_bank_phone; ''; end
def succ_bank_acct_number; ''; end
def succ_empl_other_states_yes; ''; end
def succ_empl_other_states_no; ''; end
def succ_empl_other_states_multiple; ''; end
def succ_break_in_employment_yes; ''; end
def succ_break_in_employment_no; ''; end
def succ_total_payroll_quarter; ''; end
def succ_total_payroll_year; ''; end
def succ_20th_wk_date_emp; ''; end
def succ_parent_company_name; ''; end
def succ_parent_company_fein; ''; end
def succ_officer1_name; ''; end
def succ_officer1_title; ''; end
def succ_officer1_ssn_ein; ''; end
def succ_officer1_address; ''; end
def succ_officer1_city; ''; end
def succ_officer1_state; ''; end
def succ_officer1_zip; ''; end
def succ_officer1_dob; ''; end
def succ_officer1_date_of_appt; ''; end
def succ_officer2_name; ''; end
def succ_officer2_title; ''; end
def succ_officer2_ssn_ein; ''; end
def succ_officer2_address; ''; end
def succ_officer2_city; ''; end
def succ_officer2_state; ''; end
def succ_officer2_zip; ''; end
def succ_officer2_dob; ''; end
def succ_officer2_date_of_appt; ''; end
def succ_officer3_name; ''; end
def succ_officer3_title; ''; end
def succ_officer3_ssn_ein; ''; end
def succ_officer3_address; ''; end
def succ_officer3_city; ''; end
def succ_officer3_state; ''; end
def succ_officer3_zip; ''; end
def succ_officer3_dob; ''; end
def succ_officer3_date_of_appt; ''; end
def pred_name; ''; end
def pred_dba; ''; end
def pred_fein; ''; end
def pred_phone; ''; end
def pred_corp_address; ''; end
def pred_corp_address2; ''; end
def pred_corp_city; ''; end
def pred_corp_state; ''; end
def pred_corp_zip; ''; end
def pred_contact_name; ''; end
def pred_contact_phone; ''; end
def pred_contact_mailing_address; ''; end
def pred_contact_mailing_address2; ''; end
def pred_contact_mailing_city; ''; end
def pred_contact_mailing_state; ''; end
def pred_contact_mailing_zip; ''; end
def pred_transaction_date; ''; end
def pred_operating_at_time_of_purchase_yes; ''; end
def pred_operating_at_time_of_purchase_no; ''; end
def pred_transaction_type_asset_purchase; ''; end
def pred_transaction_type_stock_purchase; ''; end
def pred_transaction_type_company_reorg; ''; end
def pred_transaction_type_salutory_merger; ''; end
def pred_transaction_type_other_checkbox; ''; end
def pred_transaction_type_other_list; ''; end
def pred_transaction_type_employee_reassignment; ''; end
def pred_transaction_type_bankruptcy_acq; ''; end
def pred_transaction_type_entity_conversion; ''; end
def pred_acq_all_employment; ''; end
def pred_acq_partial_employment; ''; end
def pred_emp_agency_yes; ''; end
def pred_emp_agency_no; ''; end
def pred_business_description; ''; end
def pred_succ_commonly_owned_yes; ''; end
def pred_succ_commonly_owned_no; ''; end
def pred_succ_commonly_owned_percent; ''; end
def pred_succ_relationship_described; ''; end
def pred_acquired_assets_acct_rec; ''; end
def pred_acquired_assets_machinery_equip; ''; end
def pred_acquired_assets_furniture_fixtures; ''; end
def pred_acquired_assets_goodwill; ''; end
def pred_acquired_assets_buildings; ''; end
def pred_acquired_assets_stock; ''; end
def pred_acquired_assets_other_real_prop_leases; ''; end
def pred_acquired_assets_customer_lists; ''; end
def pred_acquired_assets_employees; ''; end
def pred_acquired_assets_inventories; ''; end
def pred_will_report_wages_yes; ''; end
def pred_will_report_wages_no; ''; end
def pred_last_date_of_emp; ''; end
def pred_date_of_last_payroll; ''; end
def pred_parent_company_name; ''; end
def pred_parent_company_fein; ''; end
def pred_officer1_name; ''; end
def pred_officer1_title; ''; end
def pred_officer1_ssn_ein; ''; end
def pred_officer1_address; ''; end
def pred_officer1_city; ''; end
def pred_officer1_state; ''; end
def pred_officer1_zip; ''; end
def pred_officer1_dob; ''; end
def pred_officer1_date_of_appt; ''; end
def pred_officer2_name; ''; end
def pred_officer2_title; ''; end
def pred_officer2_ssn_ein; ''; end
def pred_officer2_address; ''; end
def pred_officer2_city; ''; end
def pred_officer2_state; ''; end
def pred_officer2_zip; ''; end
def pred_officer2_dob; ''; end
def pred_officer2_date_of_appt; ''; end
def pred_officer3_name; ''; end
def pred_officer3_title; ''; end
def pred_officer3_ssn_ein; ''; end
def pred_officer3_address; ''; end
def pred_officer3_city; ''; end
def pred_officer3_state; ''; end
def pred_officer3_zip; ''; end
def pred_officer3_dob; ''; end
def pred_officer3_date_of_appt; ''; end
def AK_pred_unemp_acct_number; ''; end
def AK_succ_unemp_acct_number; ''; end
def AK_pred_wh_acct_number; ''; end
def AK_address1; ''; end
def AK_city; ''; end
def AK_zip; ''; end
def AK_number_emp_transferred; ''; end
def AK_number_emp_retained; ''; end
def AK_est_mo_wages; ''; end
def AK_est_state_wh_tax; ''; end
def AL_pred_unemp_acct_number; ''; end
def AL_succ_unemp_acct_number; ''; end
def AL_pred_wh_acct_number; ''; end
def AL_address1; ''; end
def AL_city; ''; end
def AL_zip; ''; end
def AL_number_emp_transferred; ''; end
def AL_number_emp_retained; ''; end
def AL_est_mo_wages; ''; end
def AL_est_state_wh_tax; ''; end
def AR_pred_unemp_acct_number; ''; end
def AR_succ_unemp_acct_number; ''; end
def AR_pred_wh_acct_number; ''; end
def AR_address1; ''; end
def AR_city; ''; end
def AR_zip; ''; end
def AR_number_emp_transferred; ''; end
def AR_number_emp_retained; ''; end
def AR_est_mo_wages; ''; end
def AR_est_state_wh_tax; ''; end
def AZ_pred_unemp_acct_number; ''; end
def AZ_succ_unemp_acct_number; ''; end
def AZ_pred_wh_acct_number; ''; end
def AZ_address1; ''; end
def AZ_city; ''; end
def AZ_zip; ''; end
def AZ_number_emp_transferred; ''; end
def AZ_number_emp_retained; ''; end
def AZ_est_mo_wages; ''; end
def AZ_est_state_wh_tax; ''; end
def CA_pred_unemp_acct_number; ''; end
def CA_succ_unemp_acct_number; ''; end
def CA_pred_wh_acct_number; ''; end
def CA_address1; ''; end
def CA_city; ''; end
def CA_zip; ''; end
def CA_number_emp_transferred; ''; end
def CA_number_emp_retained; ''; end
def CA_est_mo_wages; ''; end
def CA_est_state_wh_tax; ''; end
def CO_pred_unemp_acct_number; ''; end
def CO_succ_unemp_acct_number; ''; end
def CO_pred_wh_acct_number; ''; end
def CO_address1; ''; end
def CO_city; ''; end
def CO_zip; ''; end
def CO_number_emp_transferred; ''; end
def CO_number_emp_retained; ''; end
def CO_est_mo_wages; ''; end
def CO_est_state_wh_tax; ''; end
def CT_pred_unemp_acct_number; ''; end
def CT_succ_unemp_acct_number; ''; end
def CT_pred_wh_acct_number; ''; end
def CT_address1; ''; end
def CT_city; ''; end
def CT_zip; ''; end
def CT_number_emp_transferred; ''; end
def CT_number_emp_retained; ''; end
def CT_est_mo_wages; ''; end
def CT_est_state_wh_tax; ''; end
def DC_pred_unemp_acct_number; ''; end
def DC_succ_unemp_acct_number; ''; end
def DC_pred_wh_acct_number; ''; end
def DC_address1; ''; end
def DC_city; ''; end
def DC_zip; ''; end
def DC_number_emp_transferred; ''; end
def DC_number_emp_retained; ''; end
def DC_est_mo_wages; ''; end
def DC_est_state_wh_tax; ''; end
def DE_pred_unemp_acct_number; ''; end
def DE_succ_unemp_acct_number; ''; end
def DE_pred_wh_acct_number; ''; end
def DE_address1; ''; end
def DE_city; ''; end
def DE_zip; ''; end
def DE_number_emp_transferred; ''; end
def DE_number_emp_retained; ''; end
def DE_est_mo_wages; ''; end
def DE_est_state_wh_tax; ''; end
def FL_pred_unemp_acct_number; ''; end
def FL_succ_unemp_acct_number; ''; end
def FL_pred_wh_acct_number; ''; end
def FL_address1; ''; end
def FL_city; ''; end
def FL_zip; ''; end
def FL_number_emp_transferred; ''; end
def FL_number_emp_retained; ''; end
def FL_est_mo_wages; ''; end
def FL_est_state_wh_tax; ''; end
def GA_pred_unemp_acct_number; ''; end
def GA_succ_unemp_acct_number; ''; end
def GA_pred_wh_acct_number; ''; end
def GA_address1; ''; end
def GA_city; ''; end
def GA_zip; ''; end
def GA_number_emp_transferred; ''; end
def GA_number_emp_retained; ''; end
def GA_est_mo_wages; ''; end
def GA_est_state_wh_tax; ''; end
def HI_pred_unemp_acct_number; ''; end
def HI_succ_unemp_acct_number; ''; end
def HI_pred_wh_acct_number; ''; end
def HI_address1; ''; end
def HI_city; ''; end
def HI_zip; ''; end
def HI_number_emp_transferred; ''; end
def HI_number_emp_retained; ''; end
def HI_est_mo_wages; ''; end
def HI_est_state_wh_tax; ''; end
def IA_pred_unemp_acct_number; ''; end
def IA_succ_unemp_acct_number; ''; end
def IA_pred_wh_acct_number; ''; end
def IA_address1; ''; end
def IA_city; ''; end
def IA_zip; ''; end
def IA_number_emp_transferred; ''; end
def IA_number_emp_retained; ''; end
def IA_est_mo_wages; ''; end
def IA_est_state_wh_tax; ''; end
def ID_pred_unemp_acct_number; ''; end
def ID_succ_unemp_acct_number; ''; end
def ID_pred_wh_acct_number; ''; end
def ID_address1; ''; end
def ID_city; ''; end
def ID_zip; ''; end
def ID_number_emp_transferred; ''; end
def ID_number_emp_retained; ''; end
def ID_est_mo_wages; ''; end
def ID_est_state_wh_tax; ''; end
def IL_pred_unemp_acct_number; ''; end
def IL_succ_unemp_acct_number; ''; end
def IL_pred_wh_acct_number; ''; end
def IL_address1; ''; end
def IL_city; ''; end
def IL_zip; ''; end
def IL_number_emp_transferred; ''; end
def IL_number_emp_retained; ''; end
def IL_est_mo_wages; ''; end
def IL_est_state_wh_tax; ''; end
def IN_pred_unemp_acct_number; ''; end
def IN_succ_unemp_acct_number; ''; end
def IN_pred_wh_acct_number; ''; end
def IN_address1; ''; end
def IN_city; ''; end
def IN_zip; ''; end
def IN_number_emp_transferred; ''; end
def IN_number_emp_retained; ''; end
def IN_est_mo_wages; ''; end
def IN_est_state_wh_tax; ''; end
def KS_pred_unemp_acct_number; ''; end
def KS_succ_unemp_acct_number; ''; end
def KS_pred_wh_acct_number; ''; end
def KS_address1; ''; end
def KS_city; ''; end
def KS_zip; ''; end
def KS_number_emp_transferred; ''; end
def KS_number_emp_retained; ''; end
def KS_est_mo_wages; ''; end
def KS_est_state_wh_tax; ''; end
def KY_pred_unemp_acct_number; ''; end
def KY_succ_unemp_acct_number; ''; end
def KY_pred_wh_acct_number; ''; end
def KY_address1; ''; end
def KY_city; ''; end
def KY_zip; ''; end
def KY_number_emp_transferred; ''; end
def KY_number_emp_retained; ''; end
def KY_est_mo_wages; ''; end
def KY_est_state_wh_tax; ''; end
def LA_pred_unemp_acct_number; ''; end
def LA_succ_unemp_acct_number; ''; end
def LA_pred_wh_acct_number; ''; end
def LA_address1; ''; end
def LA_city; ''; end
def LA_zip; ''; end
def LA_number_emp_transferred; ''; end
def LA_number_emp_retained; ''; end
def LA_est_mo_wages; ''; end
def LA_est_state_wh_tax; ''; end
def MA_pred_unemp_acct_number; ''; end
def MA_succ_unemp_acct_number; ''; end
def MA_pred_wh_acct_number; ''; end
def MA_address1; ''; end
def MA_city; ''; end
def MA_zip; ''; end
def MA_number_emp_transferred; ''; end
def MA_number_emp_retained; ''; end
def MA_est_mo_wages; ''; end
def MA_est_state_wh_tax; ''; end
def MD_pred_unemp_acct_number; ''; end
def MD_succ_unemp_acct_number; ''; end
def MD_pred_wh_acct_number; ''; end
def MD_address1; ''; end
def MD_city; ''; end
def MD_zip; ''; end
def MD_number_emp_transferred; ''; end
def MD_number_emp_retained; ''; end
def MD_est_mo_wages; ''; end
def MD_est_state_wh_tax; ''; end
def ME_pred_unemp_acct_number; ''; end
def ME_succ_unemp_acct_number; ''; end
def ME_pred_wh_acct_number; ''; end
def ME_address1; ''; end
def ME_city; ''; end
def ME_zip; ''; end
def ME_number_emp_transferred; ''; end
def ME_number_emp_retained; ''; end
def ME_est_mo_wages; ''; end
def ME_est_state_wh_tax; ''; end
def MI_pred_unemp_acct_number; ''; end
def MI_succ_unemp_acct_number; ''; end
def MI_pred_wh_acct_number; ''; end
def MI_address1; ''; end
def MI_city; ''; end
def MI_zip; ''; end
def MI_number_emp_transferred; ''; end
def MI_number_emp_retained; ''; end
def MI_est_mo_wages; ''; end
def MI_est_state_wh_tax; ''; end
def MN_pred_unemp_acct_number; ''; end
def MN_succ_unemp_acct_number; ''; end
def MN_pred_wh_acct_number; ''; end
def MN_address1; ''; end
def MN_city; ''; end
def MN_zip; ''; end
def MN_number_emp_transferred; ''; end
def MN_number_emp_retained; ''; end
def MN_est_mo_wages; ''; end
def MN_est_state_wh_tax; ''; end
def MO_pred_unemp_acct_number; ''; end
def MO_succ_unemp_acct_number; ''; end
def MO_pred_wh_acct_number; ''; end
def MO_address1; ''; end
def MO_city; ''; end
def MO_zip; ''; end
def MO_number_emp_transferred; ''; end
def MO_number_emp_retained; ''; end
def MO_est_mo_wages; ''; end
def MO_est_state_wh_tax; ''; end
def MS_pred_unemp_acct_number; ''; end
def MS_succ_unemp_acct_number; ''; end
def MS_pred_wh_acct_number; ''; end
def MS_address1; ''; end
def MS_city; ''; end
def MS_zip; ''; end
def MS_number_emp_transferred; ''; end
def MS_number_emp_retained; ''; end
def MS_est_mo_wages; ''; end
def MS_est_state_wh_tax; ''; end
def MT_pred_unemp_acct_number; ''; end
def MT_succ_unemp_acct_number; ''; end
def MT_pred_wh_acct_number; ''; end
def MT_address1; ''; end
def MT_city; ''; end
def MT_zip; ''; end
def MT_number_emp_transferred; ''; end
def MT_number_emp_retained; ''; end
def MT_est_mo_wages; ''; end
def MT_est_state_wh_tax; ''; end
def NC_pred_unemp_acct_number; ''; end
def NC_succ_unemp_acct_number; ''; end
def NC_pred_wh_acct_number; ''; end
def NC_address1; ''; end
def NC_city; ''; end
def NC_zip; ''; end
def NC_number_emp_transferred; ''; end
def NC_number_emp_retained; ''; end
def NC_est_mo_wages; ''; end
def NC_est_state_wh_tax; ''; end
def ND_pred_unemp_acct_number; ''; end
def ND_succ_unemp_acct_number; ''; end
def ND_pred_wh_acct_number; ''; end
def ND_address1; ''; end
def ND_city; ''; end
def ND_zip; ''; end
def ND_number_emp_transferred; ''; end
def ND_number_emp_retained; ''; end
def ND_est_mo_wages; ''; end
def ND_est_state_wh_tax; ''; end
def NE_pred_unemp_acct_number; ''; end
def NE_succ_unemp_acct_number; ''; end
def NE_pred_wh_acct_number; ''; end
def NE_address1; ''; end
def NE_city; ''; end
def NE_zip; ''; end
def NE_number_emp_transferred; ''; end
def NE_number_emp_retained; ''; end
def NE_est_mo_wages; ''; end
def NE_est_state_wh_tax; ''; end
def NH_pred_unemp_acct_number; ''; end
def NH_succ_unemp_acct_number; ''; end
def NH_pred_wh_acct_number; ''; end
def NH_address1; ''; end
def NH_city; ''; end
def NH_zip; ''; end
def NH_number_emp_transferred; ''; end
def NH_number_emp_retained; ''; end
def NH_est_mo_wages; ''; end
def NH_est_state_wh_tax; ''; end
def NJ_pred_unemp_acct_number; ''; end
def NJ_succ_unemp_acct_number; ''; end
def NJ_pred_wh_acct_number; ''; end
def NJ_address1; ''; end
def NJ_city; ''; end
def NJ_zip; ''; end
def NJ_number_emp_transferred; ''; end
def NJ_number_emp_retained; ''; end
def NJ_est_mo_wages; ''; end
def NJ_est_state_wh_tax; ''; end
def NM_pred_unemp_acct_number; ''; end
def NM_succ_unemp_acct_number; ''; end
def NM_pred_wh_acct_number; ''; end
def NM_address1; ''; end
def NM_city; ''; end
def NM_zip; ''; end
def NM_number_emp_transferred; ''; end
def NM_number_emp_retained; ''; end
def NM_est_mo_wages; ''; end
def NM_est_state_wh_tax; ''; end
def NV_pred_unemp_acct_number; ''; end
def NV_succ_unemp_acct_number; ''; end
def NV_pred_wh_acct_number; ''; end
def NV_address1; ''; end
def NV_city; ''; end
def NV_zip; ''; end
def NV_number_emp_transferred; ''; end
def NV_number_emp_retained; ''; end
def NV_est_mo_wages; ''; end
def NV_est_state_wh_tax; ''; end
def NY_pred_unemp_acct_number; ''; end
def NY_succ_unemp_acct_number; ''; end
def NY_pred_wh_acct_number; ''; end
def NY_address1; ''; end
def NY_city; ''; end
def NY_zip; ''; end
def NY_number_emp_transferred; ''; end
def NY_number_emp_retained; ''; end
def NY_est_mo_wages; ''; end
def NY_est_state_wh_tax; ''; end
def OH_pred_unemp_acct_number; ''; end
def OH_succ_unemp_acct_number; ''; end
def OH_pred_wh_acct_number; ''; end
def OH_address1; ''; end
def OH_city; ''; end
def OH_zip; ''; end
def OH_number_emp_transferred; ''; end
def OH_number_emp_retained; ''; end
def OH_est_mo_wages; ''; end
def OH_est_state_wh_tax; ''; end
def OK_pred_unemp_acct_number; ''; end
def OK_succ_unemp_acct_number; ''; end
def OK_pred_wh_acct_number; ''; end
def OK_address1; ''; end
def OK_city; ''; end
def OK_zip; ''; end
def OK_number_emp_transferred; ''; end
def OK_number_emp_retained; ''; end
def OK_est_mo_wages; ''; end
def OK_est_state_wh_tax; ''; end
def OR_pred_unemp_acct_number; ''; end
def OR_succ_unemp_acct_number; ''; end
def OR_pred_wh_acct_number; ''; end
def OR_address1; ''; end
def OR_city; ''; end
def OR_zip; ''; end
def OR_number_emp_transferred; ''; end
def OR_number_emp_retained; ''; end
def OR_est_mo_wages; ''; end
def OR_est_state_wh_tax; ''; end
def PA_pred_unemp_acct_number; ''; end
def PA_succ_unemp_acct_number; ''; end
def PA_pred_wh_acct_number; ''; end
def PA_address1; ''; end
def PA_city; ''; end
def PA_zip; ''; end
def PA_number_emp_transferred; ''; end
def PA_number_emp_retained; ''; end
def PA_est_mo_wages; ''; end
def PA_est_state_wh_tax; ''; end
def PR_pred_unemp_acct_number; ''; end
def PR_succ_unemp_acct_number; ''; end
def PR_pred_wh_acct_number; ''; end
def PR_address1; ''; end
def PR_city; ''; end
def PR_zip; ''; end
def PR_number_emp_transferred; ''; end
def PR_number_emp_retained; ''; end
def PR_est_mo_wages; ''; end
def PR_est_state_wh_tax; ''; end
def RI_pred_unemp_acct_number; ''; end
def RI_succ_unemp_acct_number; ''; end
def RI_pred_wh_acct_number; ''; end
def RI_address1; ''; end
def RI_city; ''; end
def RI_zip; ''; end
def RI_number_emp_transferred; ''; end
def RI_number_emp_retained; ''; end
def RI_est_mo_wages; ''; end
def RI_est_state_wh_tax; ''; end
def SC_pred_unemp_acct_number; ''; end
def SC_succ_unemp_acct_number; ''; end
def SC_pred_wh_acct_number; ''; end
def SC_address1; ''; end
def SC_city; ''; end
def SC_zip; ''; end
def SC_number_emp_transferred; ''; end
def SC_number_emp_retained; ''; end
def SC_est_mo_wages; ''; end
def SC_est_state_wh_tax; ''; end
def SD_pred_unemp_acct_number; ''; end
def SD_succ_unemp_acct_number; ''; end
def SD_pred_wh_acct_number; ''; end
def SD_address1; ''; end
def SD_city; ''; end
def SD_zip; ''; end
def SD_number_emp_transferred; ''; end
def SD_number_emp_retained; ''; end
def SD_est_mo_wages; ''; end
def SD_est_state_wh_tax; ''; end
def TN_pred_unemp_acct_number; ''; end
def TN_succ_unemp_acct_number; ''; end
def TN_pred_wh_acct_number; ''; end
def TN_address1; ''; end
def TN_city; ''; end
def TN_zip; ''; end
def TN_number_emp_transferred; ''; end
def TN_number_emp_retained; ''; end
def TN_est_mo_wages; ''; end
def TN_est_state_wh_tax; ''; end
def TX_pred_unemp_acct_number; ''; end
def TX_succ_unemp_acct_number; ''; end
def TX_pred_wh_acct_number; ''; end
def TX_address1; ''; end
def TX_city; ''; end
def TX_zip; ''; end
def TX_number_emp_transferred; ''; end
def TX_number_emp_retained; ''; end
def TX_est_mo_wages; ''; end
def TX_est_state_wh_tax; ''; end
def UT_pred_unemp_acct_number; ''; end
def UT_succ_unemp_acct_number; ''; end
def UT_pred_wh_acct_number; ''; end
def UT_address1; ''; end
def UT_city; ''; end
def UT_zip; ''; end
def UT_number_emp_transferred; ''; end
def UT_number_emp_retained; ''; end
def UT_est_mo_wages; ''; end
def UT_est_state_wh_tax; ''; end
def VA_pred_unemp_acct_number; ''; end
def VA_succ_unemp_acct_number; ''; end
def VA_pred_wh_acct_number; ''; end
def VA_address1; ''; end
def VA_city; ''; end
def VA_zip; ''; end
def VA_number_emp_transferred; ''; end
def VA_number_emp_retained; ''; end
def VA_est_mo_wages; ''; end
def VA_est_state_wh_tax; ''; end
def VI_pred_unemp_acct_number; ''; end
def VI_succ_unemp_acct_number; ''; end
def VI_pred_wh_acct_number; ''; end
def VI_address1; ''; end
def VI_city; ''; end
def VI_zip; ''; end
def VI_number_emp_transferred; ''; end
def VI_number_emp_retained; ''; end
def VI_est_mo_wages; ''; end
def VI_est_state_wh_tax; ''; end
def VT_pred_unemp_acct_number; ''; end
def VT_succ_unemp_acct_number; ''; end
def VT_pred_wh_acct_number; ''; end
def VT_address1; ''; end
def VT_city; ''; end
def VT_zip; ''; end
def VT_number_emp_transferred; ''; end
def VT_number_emp_retained; ''; end
def VT_est_mo_wages; ''; end
def VT_est_state_wh_tax; ''; end
def WA_pred_unemp_acct_number; ''; end
def WA_succ_unemp_acct_number; ''; end
def WA_pred_wh_acct_number; ''; end
def WA_address1; ''; end
def WA_city; ''; end
def WA_zip; ''; end
def WA_number_emp_transferred; ''; end
def WA_number_emp_retained; ''; end
def WA_est_mo_wages; ''; end
def WA_est_state_wh_tax; ''; end
def WI_pred_unemp_acct_number; ''; end
def WI_succ_unemp_acct_number; ''; end
def WI_pred_wh_acct_number; ''; end
def WI_address1; ''; end
def WI_city; ''; end
def WI_zip; ''; end
def WI_number_emp_transferred; ''; end
def WI_number_emp_retained; ''; end
def WI_est_mo_wages; ''; end
def WI_est_state_wh_tax; ''; end
def WV_pred_unemp_acct_number; ''; end
def WV_succ_unemp_acct_number; ''; end
def WV_pred_wh_acct_number; ''; end
def WV_address1; ''; end
def WV_city; ''; end
def WV_zip; ''; end
def WV_number_emp_transferred; ''; end
def WV_number_emp_retained; ''; end
def WV_est_mo_wages; ''; end
def WV_est_state_wh_tax; ''; end
def WY_pred_unemp_acct_number; ''; end
def WY_succ_unemp_acct_number; ''; end
def WY_pred_wh_acct_number; ''; end
def WY_address1; ''; end
def WY_city; ''; end
def WY_zip; ''; end
def WY_number_emp_transferred; ''; end
def WY_number_emp_retained; ''; end
def WY_est_mo_wages; ''; end
def WY_est_state_wh_tax; ''; end
end

class Fcc
 def applicant_middle_initial; ''; end
 def applicant_suffix; ''; end
 def applicant_address; ''; end
 def applicant_po_box; ''; end
 def applicant_city; ''; end
 def applicant_state; ''; end
 def applicant_zip; ''; end
 def applicant_country; ''; end
 def applicant_frn; ''; end
 def applicant_phone; ''; end
 def applicant_fax; ''; end
 def applicant_email; ''; end
 def contact_first_name; ''; end
 def contact_middle_initial; ''; end
 def contact_last_name; ''; end
 def contact_suffix; ''; end
 def contact_entity_name; ''; end
 def contact_address; ''; end
 def contact_po_box; ''; end
 def contact_city; ''; end
 def contact_state; ''; end
 def contact_zip; ''; end
 def contact_phone; ''; end
 def contact_fax; ''; end
 def contact_email; ''; end
 def signatory_first_name; ''; end
 def signatory_middle_initial; ''; end
 def signatory_last_name; ''; end
 def signatory_suffix; ''; end
 def signatory_title; ''; end
 def applicant_first_name; ''; end
 def applicant_last_name; ''; end
 def applicant_entity_name; ''; end
end

# ***** Field Data *****
box1_1 = ''
box1_2 = ''
box1_3 = ''
box1_4 = ''
box1_5 = ''
box1_6 = ''
box1_7 = ''
box1_8 = ''
box1_9 = ''
box1_10 = ''
box1_11 = ''
box1_12 = ''
box1_13 = ''
box1_14 = ''
box1_15 = ''
box1_16 = ''
box1_17 = ''
box1_18 = ''
box1_19 = ''
box1_20 = ''
box1_21 = ''
box1_22 = ''
box1_23 = ''
box1_24 = ''
box1_25 = ''
box1_26 = ''
box1_27 = ''
box1_28 = ''
box1_29 = ''
box1_30 = ''
box1_31 = ''
box1_32 = ''
box1_33 = ''
box1_34 = ''
box1_35 = ''
box1_36 = ''
box1_37 = ''
box1_38 = ''
box1_39 = ''
box1_40 = ''
box1_41 = ''
box1_42 = ''
box1_43 = ''
box1_44 = ''
box1_45 = ''
box1_46 = ''
box1_47 = ''
box1_48 = ''
box1_49 = ''
box1_50 = ''
box1_51 = ''
box1_52 = ''
box1_53 = ''
box1_54 = ''
box1_55 = ''
box1_56 = ''
box1_57 = ''
box1_58 = ''
box1_59 = ''
box1_60 = ''
box1_61 = ''
box1_62 = ''
box1_63 = ''
box1_64 = ''
box1_65 = ''
box1_66 = ''
box2_1 = ''
box2_2 = ''
box2_3 = ''
box2_4 = ''
box2_5 = ''
box2_6 = ''
box2_7 = ''
box2_8 = ''
box2_9 = ''
box2_10 = ''
box2_11 = ''
box2_12 = ''
box2_13 = ''
box2_14 = ''
box2_15 = ''
box2_16 = ''
box2_17 = ''
box2_18 = ''
box2_19 = ''
box2_20 = ''
box2_21 = ''
box2_22 = ''
box2_23 = ''
box2_24 = ''
box2_25 = ''
box2_26 = ''
box2_27 = ''
box2_28 = ''
box2_29 = ''
box2_30 = ''
box2_31 = ''
box2_32 = ''
box2_33 = ''
box2_34 = ''
box2_35 = ''
box2_36 = ''
box2_37 = ''
box2_38 = ''
box2_39 = ''
box2_40 = ''
box2_41 = ''
box2_42 = ''
box2_43 = ''
box2_44 = ''
box2_45 = ''
box2_46 = ''
box2_47 = ''
box2_48 = ''
box2_49 = ''
box2_50 = ''
box2_51 = ''
box2_52 = ''
box2_53 = ''
box2_54 = ''
box2_55 = ''
box2_56 = ''
box2_57 = ''
box2_58 = ''
box2_59 = ''
box2_60 = ''
box2_61 = ''
box2_62 = ''
box2_63 = ''
box2_64 = ''
box2_65 = ''
box2_66 = ''
box2_67 = ''
box2_68 = ''
box2_69 = ''
box2_70 = ''
box2_71 = ''
box2_72 = ''
box2_73 = ''
box2_74 = ''
box2_75 = ''
box2_76 = ''
box2_77 = ''
box2_78 = ''
box2_79 = ''
box2_80 = ''
box2_81 = ''
box2_82 = ''
box2_83 = ''
box2_84 = ''
box2_85 = ''
box2_86 = ''
box2_87 = ''
box2_88 = ''
box2_89 = ''
box2_90 = ''
box2_91 = ''
box2_92 = ''
box2_93 = ''
box2_94 = ''
box2_95 = ''
box2_96 = ''
box2_97 = ''
box2_98 = ''
box2_99 = ''
box2_100 = ''
box2_101 = ''
box2_102 = ''
box2_103 = ''
box2_104 = ''
box2_105 = ''
box2_106 = ''
box2_107 = ''
box2_108 = ''
box2_109 = ''
box2_110 = ''
box2_111 = ''
box2_112 = ''
box2_113 = ''
box2_114 = ''
box2_115 = ''
box2_116 = ''
box2_117 = ''
box2_118 = ''
box2_119 = ''
box2_120 = ''
box2_121 = ''
box2_122 = ''
box2_123 = ''
box2_124 = ''
box2_125 = ''
box2_126 = ''
box2_127 = ''
box2_128 = ''
box2_129 = ''
box2_130 = ''
box2_131 = ''
box2_132 = ''
box2_133 = ''
box2_134 = ''
box2_135 = ''
box2_136 = ''
box2_137 = ''
box2_138 = ''
box2_139 = ''
box2_140 = ''
box2_141 = ''
box2_142 = ''
box2_143 = ''
box2_144 = ''
box2_145 = ''
box2_146 = ''
box2_147 = ''
box2_148 = ''
box2_149 = ''
box2_150 = ''
box2_151 = ''
box2_152 = ''
box2_153 = ''
box3_1 = ''
box3_2 = ''
box3_3 = ''
box3_4 = ''
box3_5 = ''
box3_6 = ''
box3_7 = ''
box3_8 = ''
box3_9 = ''
box3_10 = ''
box3_11 = ''
box3_12 = ''
box3_13 = ''
box3_14 = ''
box3_15 = ''
box3_16 = ''
box3_17 = ''
box3_18 = ''
box3_19 = ''
box3_20 = ''
box3_21 = ''
box3_22 = ''
box3_23 = ''
box3_24 = ''
box3_25 = ''
box3_26 = ''
box3_27 = ''
box3_28 = ''
box3_29 = ''
box3_30 = ''
box3_31 = ''
box3_32 = ''
box3_33 = ''
box3_34 = ''
box3_35 = ''
box4_1 = ''
box4_2 = ''
box4_3 = ''
box4_4 = ''
box4_5 = ''
box4_6 = ''
box4_7 = ''
box4_8 = ''
box4_9 = ''
box4_10 = ''
box4_11 = ''
box4_12 = ''
box4_13 = ''
box4_14 = ''
box4_15 = ''
box4_16 = ''
box4_17 = ''
box4_18 = ''
box4_19 = ''
box4_20 = ''
box4_21 = ''
box4_22 = ''
box4_23 = ''
box4_24 = ''
box4_25 = ''
box4_26 = ''
box4_27 = ''
box4_28 = ''
box4_29 = ''
box4_30 = ''
box4_31 = ''
box4_32 = ''
box4_33 = ''
box4_34 = ''
box4_35 = ''
box4_36 = ''
box4_37 = ''
box4_38 = ''
box4_39 = ''
box4_40 = ''
box4_41 = ''
box4_42 = ''
box4_43 = ''
box4_44 = ''
box4_45 = ''
box4_46 = ''
box4_47 = ''
box4_48 = ''
box4_49 = ''
box4_50 = ''
box4_51 = ''
box4_52 = ''
box4_53 = ''
box4_54 = ''
box4_55 = ''
box4_56 = ''
box4_57 = ''
box4_58 = ''
box4_59 = ''
box4_60 = ''
box4_61 = ''
box4_62 = ''
box4_63 = ''
box4_64 = ''
box4_65 = ''
box4_66 = ''
box4_67 = ''
box4_68 = ''
box4_69 = ''
box4_70 = ''
box4_71 = ''
box4_72 = ''
box4_73 = ''
box4_74 = ''
box4_75 = ''
box4_76 = ''
box4_77 = ''
box4_78 = ''
box4_79 = ''
box4_80 = ''
box4_81 = ''
box4_82 = ''
box4_83 = ''
box4_84 = ''
box4_85 = ''
box4_86 = ''
box4_87 = ''
box4_88 = ''
box4_89 = ''
box4_90 = ''
box4_91 = ''
box4_92 = ''
box4_93 = ''
box4_94 = ''
box4_95 = ''
box4_96 = ''
box4_97 = ''
box4_98 = ''
box4_99 = ''
box4_100 = ''
box4_101 = ''
box4_102 = ''
box4_103 = ''
box4_104 = ''
box4_105 = ''
box4_106 = ''
box4_107 = ''
box4_108 = ''
box4_109 = ''
box4_110 = ''
box4_111 = ''
box4_112 = ''
box4_113 = ''
box4_114 = ''
box4_115 = ''
box4_116 = ''
box4_117 = ''
box4_118 = ''
box4_119 = ''
box4_120 = ''
box4_121 = ''
box4_122 = ''
box4_123 = ''
box4_124 = ''
box4_125 = ''
box4_126 = ''
box4_127 = ''
box4_128 = ''
box4_129 = ''
box4_130 = ''
box4_131 = ''
box4_132 = ''
box4_133 = ''
box4_134 = ''
box4_135 = ''
box4_136 = ''
box4_137 = ''
box4_138 = ''
box4_139 = ''
box4_140 = ''
box4_141 = ''
box4_142 = ''
box4_143 = ''
box4_144 = ''
box4_145 = ''
box4_146 = ''
box4_147 = ''
box4_148 = ''
box4_149 = ''
box4_150 = ''
box4_151 = ''
box4_152 = ''
box4_153 = ''
box4_154 = ''
box4_155 = ''
box4_156 = ''
box4_157 = ''
box4_158 = ''
box4_159 = ''
box4_160 = ''
box4_161 = ''
box4_162 = ''
box4_163 = ''
box4_164 = ''
box4_165 = ''
box4_166 = ''
box4_167 = ''
box4_168 = ''
box4_169 = ''
box4_170 = ''
box4_171 = ''
box4_172 = ''
box4_173 = ''
box4_174 = ''
box4_175 = ''
box4_176 = ''
box4_177 = ''
box4_178 = ''
box4_179 = ''
box4_180 = ''
box4_181 = ''
box4_182 = ''
box4_183 = ''
box4_184 = ''
box4_185 = ''
box4_186 = ''
box4_187 = ''
box4_188 = ''
box4_189 = ''
box4_190 = ''
box4_191 = ''
box4_192 = ''
box4_193 = ''
box4_194 = ''
box4_195 = ''
box4_196 = ''
box4_197 = ''
box4_198 = ''
box4_199 = ''
box4_200 = ''
box4_201 = ''
box4_202 = ''
box4_203 = ''
box4_204 = ''
box4_205 = ''
box4_206 = ''
box4_207 = ''
box4_208 = ''
box4_209 = ''
box4_210 = ''
box4_211 = ''
box4_212 = ''
box4_213 = ''
box4_214 = ''
box4_215 = ''
box4_216 = ''
box4_217 = ''
box4_218 = ''
box4_219 = ''
box4_220 = ''
box4_221 = ''
box4_222 = ''
box4_223 = ''
box4_224 = ''
box4_225 = ''
box4_226 = ''
box4_227 = ''
box4_228 = ''
box4_229 = ''
box4_230 = ''
box4_231 = ''
box4_232 = ''
box4_233 = ''
box4_234 = ''
box4_235 = ''
box4_236 = ''
box4_237 = ''
box4_238 = ''
box4_239 = ''
box4_240 = ''
box4_241 = ''
box4_242 = ''
box4_243 = ''
box4_244 = ''
box4_245 = ''
box4_246 = ''
box5_1 = ''
box5_2 = ''
box5_3 = ''
box5_4 = ''
box5_5 = ''
box5_6 = ''
box5_7 = ''
box5_8 = ''
box5_9 = ''
box5_10 = ''
box5_11 = ''
box5_12 = ''
box5_13 = ''
box5_14 = ''
box5_15 = ''
box5_16 = ''
box5_17 = ''
box5_18 = ''
box5_19 = ''
box5_20 = ''
box5_21 = ''
box5_22 = ''
box5_23 = ''
box5_24 = ''
box5_25 = ''
box5_26 = ''
box5_27 = ''
box5_28 = ''
box5_29 = ''
box5_30 = ''
box5_31 = ''
box5_32 = ''
box5_33 = ''
box5_34 = ''
box5_35 = ''
box5_36 = ''
box5_37 = ''
box5_38 = ''
box5_39 = ''
box5_40 = ''
box5_41 = ''
box5_42 = ''
box5_43 = ''
box5_44 = ''
box5_45 = ''
box5_46 = ''
box5_47 = ''
box5_48 = ''
box5_49 = ''
box5_50 = ''
box5_51 = ''
box5_52 = ''
box5_53 = ''
box5_54 = ''
box5_55 = ''
box5_56 = ''
box5_57 = ''
box5_58 = ''
box5_59 = ''
box5_60 = ''
box5_61 = ''
box5_62 = ''
box5_63 = ''
box5_64 = ''
box5_65 = ''
box5_66 = ''
box5_67 = ''
box5_68 = ''
box5_69 = ''
box6_1 = ''
box6_2 = ''
box6_3 = ''
box6_4 = ''
box6_5 = ''
box6_6 = ''
box6_7 = ''
box6_8 = ''
box6_9 = ''
box6_10 = ''
box6_11 = ''
box6_12 = ''
box6_13 = ''
box6_14 = ''
box6_15 = ''
box6_16 = ''
box6_17 = ''
box6_18 = ''
box6_19 = ''
box6_20 = ''
box6_21 = ''
box6_22 = ''
box6_23 = ''
box6_24 = ''
box6_25 = ''
box6_26 = ''
box6_27 = ''
box6_28 = ''
box6_29 = ''
box6_30 = ''
box6_31 = ''
box6_32 = ''
box6_33 = ''
box6_34 = ''
box6_35 = ''
box6_36 = ''
box6_37 = ''
box6_38 = ''
box6_39 = ''
box6_40 = ''
box6_41 = ''
box6_42 = ''
box6_43 = ''
box6_44 = ''
box6_45 = ''
box6_46 = ''
box6_47 = ''
box6_48 = ''
box6_49 = ''
box6_50 = ''
box6_51 = ''
box6_52 = ''
box6_53 = ''
box6_54 = ''
box6_55 = ''
box6_56 = ''
box6_57 = ''
box6_58 = ''
box6_59 = ''
box6_60 = ''
box6_61 = ''
box6_62 = ''
box6_63 = ''
box6_64 = ''
box6_65 = ''
box6_66 = ''
box6_67 = ''
box6_68 = ''
box6_69 = ''
box6_70 = ''
box6_71 = ''
box6_72 = ''
box6_73 = ''
box6_74 = ''
box6_75 = ''
box6_76 = ''
box7_1 = ''
box7_2 = ''
box7_3 = ''
box7_4 = ''
box7_5 = ''
box7_6 = ''
box7_7 = ''
box7_8 = ''
box7_9 = ''
box7_10 = ''
box7_11 = ''
box7_12 = ''
box7_13 = ''
box7_14 = ''
box7_15 = ''
box7_16 = ''
box7_17 = ''
box7_18 = ''
box7_19 = ''
box7_20 = ''
box7_21 = ''
box7_22 = ''
box7_23 = ''
box7_24 = ''
box7_25 = ''
box7_26 = ''
box7_27 = ''
box7_28 = ''
box7_29 = ''
box7_30 = ''
box7_31 = ''
box7_32 = ''
box7_33 = ''
box7_34 = ''
box7_35 = ''
box7_36 = ''
box7_37 = ''
box7_38 = ''
box7_39 = ''

# ***** Calculations *****

$,="\x02"
$\="\x03\n"

entity = Entity.new
preparer = Preparer.new
individual = Individual.new


tmp = entity.name.strip
print 'box1_4', tmp if !tmp.empty?

tmp = (entity.address + ' ' + entity.address2).squeeze(' ').strip
print 'box1_5', tmp if !tmp.empty?

tmp = ((entity.city.strip.empty? ? '' : entity.city + ', ') + entity.state + ' ' + entity.zip).squeeze(' ').strip
print 'box1_6', tmp if !tmp.empty?

tmp = entity.fein.strip
print 'box1_8', tmp if !tmp.empty?

tmp = entity.phone.strip
print 'box5_60', tmp if !tmp.empty?

tmp = (preparer.first_name + ' ' + preparer.middle_initial + ' ' + preparer.last_name).squeeze(' ').strip
print 'box5_59', tmp if !tmp.empty?

tmp = preparer.firm_name.strip
print 'box5_64', tmp if !tmp.empty?

tmp = ((preparer.address.empty? ? '' : preparer.address + ' ') + (preparer.city.empty? ? '' : preparer.city + ', ') + preparer.state+ ' ' + preparer.zip).squeeze(' ').strip  
print 'box5_65', tmp if !tmp.empty?

tmp = preparer.fein.strip
print 'box5_66', tmp if !tmp.empty?

tmp = if( !preparer.ptin.strip.empty? ) then preparer.ptin.strip
	else preparer.ssn.strip
	end
print 'box5_63', tmp if !tmp.empty?

tmp = preparer.phone.strip
print 'box5_67', tmp if !tmp.empty?

tmp = "#{individual.first_name} #{individual.middle_initial} #{individual.last_name} #{individual.suffix}".squeeze(' ').strip
print 'box5_57', tmp if !tmp.empty?

#
# End of DataFlow.
#

def CheckBoxCtrl(stateBox, chkList, bdg)

	#-########################################################
	#
	# Method: CheckBoxCtrl
	#
	# One checkbox in a set of checkboxes can be 'on' at a time.
	#
	# stateBox: The hidden box that holds the state of the check boxes from the last execution.
	# chkList: The sets of check boxes we are controlling.
	# bdg: The binding that gives the method read/write access to the boxes.
	#
	# IMPORTANT: THE STATE [HIDDEN] BOX MUST BE LEFT JUSTIFIED FOR THIS ROUTINE TO
	# WORK CORRECTLY.
	#
	# Each array of boxes in chkList is a set of checkboxes where 1 box at a time can be checked.
	# We uncheck the current box in a set when one of the other checkboxes in that set are checked.
	# Each set can be a different size.
	#
	# Note: checkbox sets in which one or more boxes are controlled in dataflow or regular calcs must be
	# excluded here. The user must check the list in the call to this method.
	#
	#-########################################################

	#
	# stateBox is the hidden box which stores the state values of each set in chkList separated by commas.
	# Refer to stateList as an array, init to all zeroes @ startup.
	#
	stateList = (eval("#{stateBox}", bdg).empty? ? "0," * chkList.length : eval("#{stateBox}", bdg)).split(",")

	chkList.each_index do |i|

		#
		# Determine current state expressed as a binary string which we convert to an int.
		# A correct current state is 1 bit is on and the rest are off.
		#
		curState = "0b"
		state = stateList[i].to_i

		chkList[i].each do |box| curState += eval("#{box}.empty? ? '0' : '1'", bdg) end

		curState = Integer(curState)

		#
		# We need to reset a checkbox if curState has more than one bit set.
		#
		unless (curState == state)

			# The minus sign steps into the array from the right end as these are treated as binary numbers.
			print chkList[i][-(Math.frexp(state)[1])], eval("#{chkList[i][-(Math.frexp(state)[1])]}.replace('')", bdg) if ((state & curState) > 0)
			stateList[i] = (state | curState) ^ state

			# Store state_list in the hidden box as a string with each state value separated by a comma and we are done.
			print stateBox, eval("#{stateBox}", bdg).replace(stateList.join(","))
			break
		end
	end
end

# Before we do anything we make sure the state box still exists on the form, else we do nothing with check box control.
if (defined? box1_66)
	CheckBoxCtrl(:box1_66, [[:box1_21,:box1_22],[:box1_23,:box1_24],[:box1_25,:box1_26],[:box1_27,:box1_28],[:box1_29,:box1_30],[:box5_68,:box5_69]], binding)
end

#Note- most of this form is always used, but Part IV has been blanking for years due to the minimum tax amount.  Showing minimum
#tax amounts when a form is opened is no longer an issue, but on this form it looks strange because so many lines show amounts.
#The blanking in Part IV has been incorrect, so I had to change it.  The best way to blank Part IV correctly is to just blank
#every section of the form.

#Part I
if( (box2_3 + box2_6 + box2_9 + box2_12 + box2_15 + box2_18 + box2_21 + box2_24 + box2_27 + box2_30 + box2_33 + box2_36 + box2_39 + box2_42 + box2_45 + box2_48 + box2_51 + box2_54 + box2_57 + box2_60 + box2_63 + box2_66 + box2_69 + box2_72 + box2_75 + box2_78 + box2_81 + box2_84 + box2_87 + box2_90 + box2_93 + box2_96 + box2_99 + box2_102 + box2_105 + box2_108 + box2_111 + box2_114 + box2_117 + box2_120 + box2_123 + box2_126 + box2_129 + box2_132 + box2_135 + box2_138 + box2_141 + box2_144 + box2_147 + box2_150).strip.length == 0 )
	box2_151 = ''
else
	box2_151 = '%0.0f' % (box2_3.to_f + box2_6.to_f + box2_9.to_f + box2_12.to_f + box2_15.to_f + box2_18.to_f + box2_21.to_f + box2_24.to_f + box2_27.to_f + box2_30.to_f + box2_33.to_f + box2_36.to_f + box2_39.to_f + box2_42.to_f + box2_45.to_f + box2_48.to_f + box2_51.to_f + box2_54.to_f + box2_57.to_f + box2_60.to_f + box2_63.to_f + box2_66.to_f + box2_69.to_f + box2_72.to_f + box2_75.to_f + box2_78.to_f + box2_81.to_f + box2_84.to_f + box2_87.to_f + box2_90.to_f + box2_93.to_f + box2_96.to_f + box2_99.to_f + box2_102.to_f + box2_105.to_f + box2_108.to_f + box2_111.to_f + box2_114.to_f + box2_117.to_f + box2_120.to_f + box2_123.to_f + box2_126.to_f + box2_129.to_f + box2_132.to_f + box2_135.to_f + box2_138.to_f + box2_141.to_f + box2_144.to_f + box2_147.to_f + box2_150.to_f)
end
print 'box2_151', box2_151
#End of Part I

#Part V- needed for Part II
#Only the totals at the bottom of Part V are calcing.  We've never had calcs in Columns C or E probably because Column A can be
#positive or negative and these types of sections are normally positive amounts only.  It is not clear how to correctly calc this
#section because of this issue even though Column C has instructions at the top of the column.
if( ( box5_4 + box5_9 + box5_14 + box5_19 + box5_24 + box5_29 + box5_34 + box5_39 + box5_44 + box5_49 + box5_53 + box5_5 + box5_10 + box5_15 + box5_20 + box5_25 + box5_30 + box5_35 + box5_40 + box5_45 + box5_50 + box5_54).strip.length == 0 )
	box5_55 = ''
	box5_56 = ''
else
	box5_55 = '%0.0f' % (box5_4.to_f + box5_9.to_f + box5_14.to_f + box5_19.to_f + box5_24.to_f + box5_29.to_f + box5_34.to_f + box5_39.to_f + box5_44.to_f + box5_49.to_f + box5_53.to_f)
	box5_56 = '%0.0f' % (box5_5.to_f + box5_10.to_f + box5_15.to_f + box5_20.to_f + box5_25.to_f + box5_30.to_f + box5_35.to_f + box5_40.to_f + box5_45.to_f + box5_50.to_f + box5_54.to_f)
end
print 'box5_55', box5_55
print 'box5_56', box5_56
#End of Part V

#Parts II and III- Combined Total page
#This page has never added the amounts from the parent and affiliates columns on page 3.  Maybe because the filer could have more
#affiliates on attached pages.  There haven't been any customer complaints, so leaving as is.
if( ( box3_1 + box3_2 + box3_3 + box3_4 + box3_5 + box3_6 + box3_7 + box3_8 + box3_10 + box3_11 + box3_13 + box3_14 + box3_16 + box3_17 + box3_18 + box3_19 + box3_20 + box3_21 + box3_22 + box3_23 + box3_24 + box3_25 + box3_29 + box3_34 + box5_55 ).strip.length == 0 )
	box3_9 = ''
	box3_12 = ''
	box3_15 = ''
	box3_26 = ''
	box3_27 = ''
	box3_28 = ''
	box3_30 = ''
	box3_31 = ''
	box3_32 = ''
	box3_33 = ''
	box3_35 = ''
else
	box3_9 = '%0.0f' % (box3_1.to_f + box3_2.to_f + box3_3.to_f + box3_4.to_f + box3_5.to_f + box3_6.to_f + box3_7.to_f + box3_8.to_f)
	box3_12 = '%0.0f' % (box3_10.to_f - box3_11.to_f)
	box3_15 = '%0.0f' % (box3_13.to_f - box3_14.to_f)
	box3_26 = '%0.0f' % (box3_12.to_f + box3_15.to_f + box3_16.to_f + box3_17.to_f + box3_18.to_f + box3_19.to_f + box3_20.to_f + box3_21.to_f + box3_22.to_f + box3_23.to_f + box3_24.to_f + box3_25.to_f)
	box3_27 = '%0.0f' % (box3_9.to_f - box3_26.to_f)
	box3_28 = box3_27
	#Disallow a negative even though the user is not supposed to enter an amount on line 25 larger than line 24.  If a negative
	#shows on this line then line 27 doesn't calc correctly.
	box3_30 = '%0.0f' % (box3_28.to_f > box3_29.to_f ? box3_28.to_f - box3_29.to_f : 0)
	if (box5_55.strip.empty?)
		box3_31 = ''
	else 
		box3_31 = '%0.0f' % [box3_30.to_f,box5_55.to_f].min
	end
	box3_32 = '%0.0f' % (box3_30.to_f > box3_31.to_f ? box3_30.to_f - box3_31.to_f : 0)
	box3_33 = '%0.0f' % (box3_32.to_f * 0.075)
	box3_35 = '%0.0f' % (box3_34.to_f * 0.0031)
end
print 'box3_9', box3_9
print 'box3_12', box3_12
print 'box3_15', box3_15
print 'box3_26', box3_26
print 'box3_27', box3_27
print 'box3_28', box3_28
print 'box3_30', box3_30
print 'box3_31', box3_31
print 'box3_32', box3_32
print 'box3_33', box3_33
print 'box3_35', box3_35
#End of Parts II and III- Combined Total page

#Part IV- lines 1-11 (line 11 is needed for Schedule KC)
#Line 1 was only posting from Part I if it was greater than zero and Part IV was blanking unless line 1 was greater than zero.  There
#is nothing in the instructions about this and there never has been that I can find.  This blanking was added in 2005.  The 2004 form
#was incorrectly calcing the minimum $250 tax and it appears the blanking was added the next year when the minimum tax calc was
#corrected to keep $250 from showing when the form was opened.  This section is always used and amounts from Parts II and III
#should post regardless of whether line 1 is greater than zero, so I'm removing the greater than zero code.
box1_31 = box2_151
print 'box1_31', box1_31

box1_32 = box3_33
print 'box1_32', box1_32

box1_33 = box3_35
print 'box1_33', box1_33

if( ( box1_31 + box1_32 + box1_33 + box1_35 + box1_38 + box1_43 ).strip.length == 0 )
	box1_34 = ''
	box1_36 = ''
	box1_37 = ''
	box1_39 = ''
	box1_40 = ''
	box1_41 = ''
	box1_42 = ''
	box1_44 = ''
	box1_45 = ''
else
	box1_34 = '%0.0f' % [box1_32.to_f, box1_33.to_f, 250.0].max
	box1_36 = '%0.0f' % (box1_34.to_f + box1_35.to_f)
	box1_37 = '%0.0f' % (box1_34.to_f == 250.0 ? 0 : box1_34.to_f * 0.10)
	box1_39 = '%0.0f' % (box1_36.to_f + box1_37.to_f + box1_38.to_f)
	box1_40 = '%0.0f' % (box1_31.to_f > box1_39.to_f ? box1_31.to_f - box1_39.to_f : 0.0)
	box1_40 = '%0.0f' % 500000 if box1_40.to_f > 500000.0
	box1_41 = '%0.0f' % (box1_39.to_f + box1_40.to_f)
	box1_42 = '%0.0f' % (box1_41.to_f * 0.30)
	box1_44 = '%0.0f' % [box1_42.to_f, box1_43.to_f].max
	box1_45 = '%0.0f' % (box1_41.to_f > box1_44.to_f ? box1_41.to_f - box1_44.to_f : 0.0)
end
print 'box1_34', box1_34
print 'box1_36', box1_36
print 'box1_37', box1_37
print 'box1_39', box1_39
print 'box1_40', box1_40
print 'box1_41', box1_41
print 'box1_42', box1_42
print 'box1_44', box1_44
print 'box1_45', box1_45
#End of Part IV- lines 1-11

#Schedule KC
#Part I-B
if( ( box6_2 + box6_3 + box6_4 + box6_5 ).strip.length == 0 )
	box6_6 = ''
	box6_7 = ''
else
	box6_6 = '%0.0f' % (box6_2.to_f + box6_4.to_f)
	box6_7 = '%0.0f' % (box6_3.to_f + box6_5.to_f)
end
print 'box6_6', box6_6
print 'box6_7', box6_7
#End of Part I-B

#Part I-C
if( ( box6_8 + box6_9 + box6_10 + box6_11 + box6_12 + box6_13 + box6_14 + box6_15 + box6_16 + box6_17 + box6_18 + box6_19 + box6_20).strip.length == 0 )
	box6_21 = ''
else
	box6_21 = '%0.0f' % (box6_8.to_f + box6_9.to_f + box6_10.to_f + box6_11.to_f + box6_12.to_f + box6_13.to_f + box6_14.to_f + box6_15.to_f + box6_16.to_f + box6_17.to_f + box6_18.to_f + box6_19.to_f + box6_20.to_f)
end
print 'box6_21', box6_21
#End of Part I-C

#Part I-D
#Column D hasn't been calcing and the instructions just say to enter the available credit, so it may not be something we can calc.
if( (box6_22 + box6_23 + box6_24 + box6_25 + box6_26 + box6_27 + box6_28 + box6_29 + box6_30 + box6_31 + box6_32 + box6_33 + box6_34 + box6_36 + box6_37 + box6_38 + box6_39 + box6_40 + box6_41 + box6_42 + box6_43 + box6_44 + box6_45 + box6_46 + box6_47 + box6_49 + box6_50 + box6_51 + box6_52 + box6_53 + box6_54 + box6_55 + box6_56 + box6_57 + box6_58 + box6_59 + box6_60 + box6_61 + box6_63 + box6_64 + box6_65 + box6_66 + box6_67 + box6_68 + box6_69 + box6_70 + box6_71 + box6_72 + box6_73 + box6_74 + box6_75).strip.length == 0 )

	box6_35 = ''
	box6_48 = ''
	box6_62 = ''
	box6_76 = ''
else
	box6_35 = '%0.0f' % (box6_22.to_f + box6_23.to_f + box6_24.to_f + box6_25.to_f + box6_26.to_f + box6_27.to_f + box6_28.to_f + box6_29.to_f + box6_30.to_f + box6_31.to_f + box6_32.to_f + box6_33.to_f + box6_34.to_f)

	box6_48 = '%0.0f' % (box6_36.to_f + box6_37.to_f + box6_38.to_f + box6_39.to_f + box6_40.to_f + box6_41.to_f + box6_42.to_f + box6_43.to_f + box6_44.to_f + box6_45.to_f + box6_46.to_f + box6_47.to_f)

	box6_62 = '%0.0f' % (box6_49.to_f + box6_50.to_f + box6_51.to_f + box6_52.to_f + box6_53.to_f + box6_54.to_f + box6_55.to_f + box6_56.to_f + box6_57.to_f + box6_58.to_f + box6_59.to_f + box6_60.to_f + box6_61.to_f)

	box6_76 = '%0.0f' % (box6_63.to_f + box6_64.to_f + box6_65.to_f + box6_66.to_f + box6_67.to_f + box6_68.to_f + box6_69.to_f + box6_70.to_f + box6_71.to_f + box6_72.to_f + box6_73.to_f + box6_74.to_f + box6_75.to_f)
end
print 'box6_35', box6_35
print 'box6_48', box6_48
print 'box6_62', box6_62
print 'box6_76', box6_76
#End of Part I-D

#Part II
#We should allow zeros to show on lines posting from sections in Part I that aren't used due to the way this section calcs.
if( ( box6_1 + box6_6 + box6_21 + box6_62 + box7_3 ).strip.length == 0 )
	box7_5 = ''
	box7_6 = ''
	box7_7 = ''
	box7_8 = ''
	box7_9 = ''
	box7_10 = ''
	box7_11 = ''
	box7_12 = ''
	box7_13 = ''
	box7_14 = ''
	box7_15 = ''
else
	box7_5 = box1_45
	box7_6 = '%0.0f' % [box6_1.to_f, box7_5.to_f].min
	box7_7 = '%0.0f' % (box7_5.to_f - box7_6.to_f)
	box7_8 = '%0.0f' % [box6_6.to_f, box7_7.to_f].min
	box7_9 = '%0.0f' % (box7_7.to_f - box7_8.to_f)
	box7_10 = '%0.0f' % [box6_21.to_f, box7_9.to_f].min
	box7_11 = '%0.0f' % (box7_9.to_f - box7_10.to_f)
	box7_12 = '%0.0f' % [box6_62.to_f, box7_11.to_f].min
	box7_13 = '%0.0f' % (box7_11.to_f - box7_12.to_f)
	box7_14 = '%0.0f' % [box7_3.to_f, box7_13.to_f].min
	box7_15 = '%0.0f' % [box7_6.to_f + box7_8.to_f + box7_10.to_f + box7_12.to_f + box7_14.to_f, box7_5.to_f].min
end
print 'box7_5', box7_5
print 'box7_6', box7_6
print 'box7_7', box7_7
print 'box7_8', box7_8
print 'box7_9', box7_9
print 'box7_10', box7_10
print 'box7_11', box7_11
print 'box7_12', box7_12
print 'box7_13', box7_13
print 'box7_14', box7_14
print 'box7_15', box7_15
#End of Schedule KC 

#Part IV- lines 12-18
#Schedule KC Part II line 11 should never be greater than Part IV line 11 due to the calcs in Schedule KC, but it doesn't hurt to
#calc it again in case the user overrides any calcs in Schedule KC.
if( ( box1_41 + box1_45 + box1_48 + box1_49 + box1_50 + box1_53 + box1_54 + box1_55 + box7_15 ).strip.length == 0 )
	box1_46 = ''
	box1_47 = ''
	box1_51 = ''
	box1_52 = ''
	box1_56 = ''
	box1_65 = ''
else
	box1_46 = (box7_15.to_f > box1_45.to_f ? box1_45 : box7_15)
	box1_47 = '%0.0f' % (box1_41.to_f > box1_46.to_f ? box1_41.to_f - box1_46.to_f : 0.0)
	box1_51 = '%0.0f' % (box1_48.to_f + box1_49.to_f + box1_50.to_f)

	#We're letting a negative balance due show so user can decide how to enter it on line 17.
	box1_52 = '%0.0f' % (box1_47.to_f - box1_51.to_f)

	box1_56 = '%0.0f' % (box1_53.to_f + box1_54.to_f + box1_55.to_f)
	box1_65 = '%0.0f' % (box1_52.to_f + box1_56.to_f)
	box1_65 = '%0.0f' % 0 if box1_65.to_f < 0.0
end
print 'box1_46', box1_46
print 'box1_47', box1_47
print 'box1_51', box1_51
print 'box1_52', box1_52
print 'box1_56', box1_56
print 'box1_65', box1_65
#End of Part IV- lines 12-18

#Parts II and III- Parent and Affiliates page
if ((box4_5 + box4_6 + box4_7 + box4_8 + box4_9 + box4_10 + box4_11 + box4_12 + box4_14 + box4_15 + box4_16 + box4_17 + box4_18 + box4_19 + box4_20 + box4_21 + box4_22 + box4_23 + box4_24 + box4_25 + box4_28 + box4_30 + box4_32 + box4_33 + box4_35).strip.length > 0)

	box4_13 = $CUR % (box4_5.to_f + box4_6.to_f + box4_7.to_f + box4_8.to_f + box4_9.to_f + box4_10.to_f + box4_11.to_f + box4_12.to_f)
	box4_26 = $CUR % (box4_14.to_f + box4_15.to_f + box4_16.to_f + box4_17.to_f + box4_18.to_f + box4_19.to_f + box4_20.to_f + box4_21.to_f + box4_22.to_f + box4_23.to_f + box4_24.to_f + box4_25.to_f)
	box4_27 = $CUR % (box4_13.to_f - box4_26.to_f)
	box4_29 = $CUR % (box4_28.strip.empty? ? box4_27.to_f : box4_27.to_f * ".#{box4_28}".to_f)
	box4_31 = $CUR % (box4_29.to_f - box4_30.to_f)
	box4_34 = $CUR % (box4_33.strip.empty? ? box4_32.to_f : box4_32.to_f * ".#{box4_33}".to_f) 
	box4_36 = $CUR % ((box4_34.to_f * box4_35.to_f) / 12.0)
else
	box4_13 = ''
	box4_26 = ''
	box4_27= ''
	box4_29 = ''
	box4_31 = ''
	box4_34 = ''
	box4_36 = ''
end

print 'box4_13', box4_13
print 'box4_26', box4_26
print 'box4_27', box4_27
print 'box4_29', box4_29
print 'box4_31', box4_31
print 'box4_34', box4_34
print 'box4_36', box4_36

if ((box4_40 + box4_41 + box4_42 + box4_43 + box4_44 + box4_45 + box4_46 + box4_47 + box4_49 + box4_50 + box4_51 + box4_52 + box4_53 + box4_54 + box4_55 + box4_56 + box4_57 + box4_58 + box4_59 + box4_60 + box4_63 + box4_65 + box4_67 + box4_68 + box4_70).strip.length > 0)

	box4_48 = $CUR % (box4_40.to_f + box4_41.to_f + box4_42.to_f + box4_43.to_f + box4_44.to_f + box4_45.to_f + box4_46.to_f + box4_47.to_f)
	box4_61 = $CUR % (box4_49.to_f + box4_50.to_f + box4_51.to_f + box4_52.to_f + box4_53.to_f + box4_54.to_f + box4_55.to_f + box4_56.to_f + box4_57.to_f + box4_58.to_f + box4_59.to_f + box4_60.to_f)
	box4_62 = $CUR % (box4_48.to_f - box4_61.to_f)
	box4_64 = $CUR % (box4_63.strip.empty? ? box4_62.to_f : box4_62.to_f * ".#{box4_63}".to_f)
	box4_66 = $CUR % (box4_64.to_f - box4_65.to_f)
	box4_69 = $CUR % (box4_68.strip.empty? ? box4_67.to_f : box4_67.to_f * ".#{box4_68}".to_f) 
	box4_71 = $CUR % ((box4_69.to_f * box4_70.to_f) / 12.0)
else
	box4_48 = ''
	box4_61 = ''
	box4_62= ''
	box4_64 = ''
	box4_66 = ''
	box4_69 = ''
	box4_71 = ''
end

print 'box4_48', box4_48
print 'box4_61', box4_61
print 'box4_62', box4_62
print 'box4_64', box4_64
print 'box4_66', box4_66
print 'box4_69', box4_69
print 'box4_71', box4_71


if ((box4_75 + box4_76 + box4_77 + box4_78 + box4_79 + box4_80 + box4_81 + box4_82 + box4_84 + box4_85 + box4_86 + box4_87 + box4_88 + box4_89 + box4_90 + box4_91 + box4_92 + box4_93 + box4_94 + box4_95 + box4_98 + box4_100 + box4_102 + box4_103 + box4_105).strip.length > 0)

	box4_83 = $CUR % (box4_75.to_f + box4_76.to_f + box4_77.to_f + box4_78.to_f + box4_79.to_f + box4_80.to_f + box4_81.to_f + box4_82.to_f)
	box4_96 = $CUR % (box4_84.to_f + box4_85.to_f + box4_86.to_f + box4_87.to_f + box4_88.to_f + box4_89.to_f + box4_90.to_f + box4_91.to_f + box4_92.to_f + box4_93.to_f + box4_94.to_f + box4_95.to_f)
	box4_97 = $CUR % (box4_83.to_f - box4_96.to_f)
	box4_99 = $CUR % (box4_98.strip.empty? ? box4_97.to_f : box4_97.to_f * ".#{box4_98}".to_f)
	box4_101 = $CUR % (box4_99.to_f - box4_100.to_f)
	box4_104 = $CUR % (box4_103.strip.empty? ? box4_102.to_f : box4_102.to_f * ".#{box4_103}".to_f) 
	box4_106 = $CUR % ((box4_104.to_f * box4_105.to_f) / 12.0)
else
	box4_83 = ''
	box4_96 = ''
	box4_97= ''
	box4_99 = ''
	box4_101 = ''
	box4_104 = ''
	box4_106 = ''
end

print 'box4_83', box4_83
print 'box4_96', box4_96
print 'box4_97', box4_97
print 'box4_99', box4_99
print 'box4_101', box4_101
print 'box4_104', box4_104
print 'box4_106', box4_106

if ((box4_110 + box4_111 + box4_112 + box4_113 + box4_114 + box4_115 + box4_116 + box4_117 + box4_119 + box4_120 + box4_121 + box4_122 + box4_123 + box4_124 + box4_125 + box4_126 + box4_127 + box4_128 + box4_129 + box4_130 + box4_133 + box4_135 + box4_137 + box4_138 + box4_140).strip.length > 0)

	box4_118 = $CUR % (box4_110.to_f + box4_111.to_f + box4_112.to_f + box4_113.to_f + box4_114.to_f + box4_115.to_f + box4_116.to_f + box4_117.to_f)
	box4_131 = $CUR % (box4_119.to_f + box4_120.to_f + box4_121.to_f + box4_122.to_f + box4_123.to_f + box4_124.to_f + box4_125.to_f + box4_126.to_f + box4_127.to_f + box4_128.to_f + box4_129.to_f + box4_130.to_f)
	box4_132 = $CUR % (box4_118.to_f - box4_131.to_f)
	box4_134 = $CUR % (box4_133.strip.empty? ? box4_132.to_f : box4_132.to_f * ".#{box4_133}".to_f)
	box4_136 = $CUR % (box4_134.to_f - box4_135.to_f)
	box4_139 = $CUR % (box4_138.strip.empty? ? box4_137.to_f : box4_137.to_f * ".#{box4_138}".to_f) 
	box4_141 = $CUR % ((box4_139.to_f * box4_140.to_f) / 12.0)
else
	box4_118 = ''
	box4_131 = ''
	box4_132= ''
	box4_134 = ''
	box4_136 = ''
	box4_139 = ''
	box4_141 = ''
end

print 'box4_118', box4_118
print 'box4_131', box4_131
print 'box4_132', box4_132
print 'box4_134', box4_134
print 'box4_136', box4_136
print 'box4_139', box4_139
print 'box4_141', box4_141

if ((box4_145 + box4_146 + box4_147 + box4_148 + box4_149 + box4_150 + box4_151 + box4_152 + box4_154 + box4_155 + box4_156 + box4_157 + box4_158 + box4_159 + box4_160 + box4_161 + box4_162 + box4_163 + box4_164 + box4_165 + box4_168 + box4_170 + box4_172 + box4_173 + box4_175).strip.length > 0)

	box4_153 = $CUR % (box4_145.to_f + box4_146.to_f + box4_147.to_f + box4_148.to_f + box4_149.to_f + box4_150.to_f + box4_151.to_f + box4_152.to_f)
	box4_166 = $CUR % (box4_154.to_f + box4_155.to_f + box4_156.to_f + box4_157.to_f + box4_158.to_f + box4_159.to_f + box4_160.to_f + box4_161.to_f + box4_162.to_f + box4_163.to_f + box4_164.to_f + box4_165.to_f)
	box4_167 = $CUR % (box4_153.to_f - box4_166.to_f)
	box4_169 = $CUR % (box4_168.strip.empty? ? box4_167.to_f : box4_167.to_f * ".#{box4_168}".to_f)
	box4_171 = $CUR % (box4_169.to_f - box4_170.to_f)
	box4_174 = $CUR % (box4_173.strip.empty? ? box4_172.to_f : box4_172.to_f * ".#{box4_173}".to_f) 
	box4_176 = $CUR % ((box4_174.to_f * box4_175.to_f) / 12.0)
else
	box4_153 = ''
	box4_166 = ''
	box4_167= ''
	box4_169 = ''
	box4_171 = ''
	box4_174 = ''
	box4_176 = ''
end

print 'box4_153', box4_153
print 'box4_166', box4_166
print 'box4_167', box4_167
print 'box4_169', box4_169
print 'box4_171', box4_171
print 'box4_174', box4_174
print 'box4_176', box4_176

if ((box4_180 + box4_181 + box4_182 + box4_183 + box4_184 + box4_185 + box4_186 + box4_187 + box4_189 + box4_190 + box4_191 + box4_192 + box4_193 + box4_194 + box4_195 + box4_196 + box4_197 + box4_198 + box4_199 + box4_200 + box4_203 + box4_205 + box4_207 + box4_208 + box4_210).strip.length > 0)

	box4_188 = $CUR % (box4_180.to_f + box4_181.to_f + box4_182.to_f + box4_183.to_f + box4_184.to_f + box4_185.to_f + box4_186.to_f + box4_187.to_f)
	box4_201 = $CUR % (box4_189.to_f + box4_190.to_f + box4_191.to_f + box4_192.to_f + box4_193.to_f + box4_194.to_f + box4_195.to_f + box4_196.to_f + box4_197.to_f + box4_198.to_f + box4_199.to_f + box4_200.to_f)
	box4_202 = $CUR % (box4_188.to_f - box4_201.to_f)
	box4_204 = $CUR % (box4_203.strip.empty? ? box4_202.to_f : box4_202.to_f * ".#{box4_203}".to_f)
	box4_206 = $CUR % (box4_204.to_f - box4_205.to_f)
	box4_209 = $CUR % (box4_208.strip.empty? ? box4_207.to_f : box4_207.to_f * ".#{box4_208}".to_f) 
	box4_211 = $CUR % ((box4_209.to_f * box4_210.to_f) / 12.0)
else
	box4_188 = ''
	box4_201 = ''
	box4_202= ''
	box4_204 = ''
	box4_206 = ''
	box4_209 = ''
	box4_211 = ''
end

print 'box4_188', box4_188
print 'box4_201', box4_201
print 'box4_202', box4_202
print 'box4_204', box4_204
print 'box4_206', box4_206
print 'box4_209', box4_209
print 'box4_211', box4_211

if ((box4_215 + box4_216 + box4_217 + box4_218 + box4_219 + box4_220 + box4_221 + box4_222 + box4_224 + box4_225 + box4_226 + box4_227 + box4_228 + box4_229 + box4_230 + box4_231 + box4_232 + box4_233 + box4_234 + box4_235 + box4_238 + box4_240 + box4_242 + box4_243 + box4_245).strip.length > 0)

	box4_223 = $CUR % (box4_215.to_f + box4_216.to_f + box4_217.to_f + box4_218.to_f + box4_219.to_f + box4_220.to_f + box4_221.to_f + box4_222.to_f)
	box4_236 = $CUR % (box4_224.to_f + box4_225.to_f + box4_226.to_f + box4_227.to_f + box4_228.to_f + box4_229.to_f + box4_230.to_f + box4_231.to_f + box4_232.to_f + box4_233.to_f + box4_234.to_f + box4_235.to_f)
	box4_237 = $CUR % (box4_223.to_f - box4_236.to_f)
	box4_239 = $CUR % (box4_238.strip.empty? ? box4_237.to_f : box4_237.to_f * ".#{box4_238}".to_f)
	box4_241 = $CUR % (box4_239.to_f - box4_240.to_f)
	box4_244 = $CUR % (box4_243.strip.empty? ? box4_242.to_f : box4_242.to_f * ".#{box4_243}".to_f) 
	box4_246 = $CUR % ((box4_244.to_f * box4_245.to_f) / 12.0)
else
	box4_223 = ''
	box4_236 = ''
	box4_237= ''
	box4_239 = ''
	box4_241 = ''
	box4_244 = ''
	box4_246 = ''
end

print 'box4_223', box4_223
print 'box4_236', box4_236
print 'box4_237', box4_237
print 'box4_239', box4_239
print 'box4_241', box4_241
print 'box4_244', box4_244
print 'box4_246', box4_246
#End of Parts II and III- Parent and Affiliates page
